package xyz.brassgoggledcoders.boilerplate.lib.common.utils;

import java.util.Iterator;
import java.util.List;

import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.network.Packet;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.IChatComponent;
import net.minecraft.util.MathHelper;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.Vec3;
import net.minecraft.world.World;

public class PlayerUtils
{
	// DOES NOT get entities
	public static MovingObjectPosition getTargetBlock(World world, Entity player, boolean par3, double range)
	{
		float f = 1.0F;
		float f1 = player.field_70127_C + ((player.field_70125_A - player.field_70127_C) * f);
		float f2 = player.field_70126_B + ((player.field_70177_z - player.field_70126_B) * f);
		double d0 = player.field_70169_q + ((player.field_70165_t - player.field_70169_q) * f);
		double d1 = player.field_70167_r + ((player.field_70163_u - player.field_70167_r) * f);
		if (!world.field_72995_K && (player instanceof EntityPlayer))
		{
			d1 += 1.62D;
		}
		double d2 = player.field_70166_s + ((player.field_70161_v - player.field_70166_s) * f);
		Vec3 vec3 = new Vec3(d0, d1, d2);
		float f3 = MathHelper.func_76134_b((-f2 * 0.017453292F) - (float) Math.PI);
		float f4 = MathHelper.func_76126_a((-f2 * 0.017453292F) - (float) Math.PI);
		float f5 = -MathHelper.func_76134_b(-f1 * 0.017453292F);
		float f6 = MathHelper.func_76126_a(-f1 * 0.017453292F);
		float f7 = f4 * f5;
		float f8 = f3 * f5;
		double d3 = range;
		Vec3 vec31 = vec3.func_72441_c(f7 * d3, f6 * d3, f8 * d3);
		return world.func_147447_a(vec3, vec31, par3, !par3, par3);
	}

	public static Entity getPointedEntity(World world, Entity entityplayer, double range)
	{
		Entity pointedEntity = null;
		double d = range;
		Vec3 vec3d = new Vec3(entityplayer.field_70165_t, entityplayer.field_70163_u + entityplayer.func_70047_e(), entityplayer.field_70161_v);

		Vec3 vec3d1 = entityplayer.func_70040_Z();
		Vec3 vec3d2 = vec3d.func_72441_c(vec3d1.field_72450_a * d, vec3d1.field_72448_b * d, vec3d1.field_72449_c * d);

		float f1 = 1.1F;
		List list = world.func_72839_b(entityplayer,
				entityplayer.func_174813_aQ().func_72321_a(vec3d1.field_72450_a * d, vec3d1.field_72448_b * d, vec3d1.field_72449_c * d).func_72314_b(f1, f1, f1));

		double d2 = 0.0D;
		for (int i = 0; i < list.size(); i++)
		{
			Entity entity = (Entity) list.get(i);
			if (((entity.func_70067_L())
					&& (world.func_147447_a(new Vec3(entityplayer.field_70165_t, entityplayer.field_70163_u + entityplayer.func_70047_e(), entityplayer.field_70161_v),
							new Vec3(entity.field_70165_t, entity.field_70163_u + entity.func_70047_e(), entity.field_70161_v), false, true, false) == null)))
			{
				float f2 = Math.max(0.8F, entity.func_70111_Y());
				AxisAlignedBB axisalignedbb = entity.func_174813_aQ().func_72314_b(f2, f2, f2);
				MovingObjectPosition movingobjectposition = axisalignedbb.func_72327_a(vec3d, vec3d2);

				if (axisalignedbb.func_72318_a(vec3d))
				{
					if ((0.0D < d2) || (d2 == 0.0D))
					{
						pointedEntity = entity;
						d2 = 0.0D;
					}

				}
				else if (movingobjectposition != null)
				{
					double d3 = vec3d.func_72438_d(movingobjectposition.field_72307_f);
					if ((d3 < d2) || (d2 == 0.0D))
					{
						pointedEntity = entity;
						d2 = d3;
					}
				}
			}
		}
		return pointedEntity;
	}

	public static void sendMessage(EntityPlayer player, String message)
	{
		IChatComponent chat = new ChatComponentText(message);

		if (!player.field_70170_p.field_72995_K)
		{
			player.func_145747_a(chat);
		}
	}

	public static void sendToPlayers(Packet packet, World world, int x, int y, int z, Integer maxDistance)
	{
		if (maxDistance == null)
		{
			maxDistance = 128;
		}

		Iterator<?> iterator;

		if (packet != null)
		{
			for (iterator = world.field_73010_i.iterator(); iterator.hasNext();)
			{
				Object player = iterator.next();
				EntityPlayerMP playerMP = (EntityPlayerMP) player;

				if ((Math.abs(playerMP.field_70165_t - x) <= maxDistance) && (Math.abs(playerMP.field_70163_u - y) <= maxDistance)
						&& (Math.abs(playerMP.field_70161_v - z) <= maxDistance))
				{
					playerMP.field_71135_a.func_147359_a(packet);
				}
			}
		}
	}

	/*
	 * TODO: Chat stuff
	 * 
	 * @SuppressWarnings("all") public static void sendChatToServer(String
	 * message) { List<EntityPlayerMP> players =
	 * MinecraftServer.getServer().worldServers[0].playerEntities; for (int t =
	 * 0; t < players.size(); t++) { players.get(t).addChatMessage(new
	 * ChatComponentText(message)); } }
	 */
}
